Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1691610 - Review Request: python-elpy - Backend for the elpy Emacs mode
Summary: Review Request: python-elpy - Backend for the elpy Emacs mode
Keywords:
Status: ASSIGNED
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Chris Caron
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: python-yapf
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-03-22 03:55 UTC by Luis Bazan
Modified: 2019-04-08 14:04 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:


Attachments (Terms of Use)

Description Luis Bazan 2019-03-22 03:55:35 UTC
SPEC: https://lbazan.fedorapeople.org/python-elpy.spec
SRPM: https://lbazan.fedorapeople.org/python-elpy-1.28.0-1.fc29.src.rpm

Description:
Elpy is an Emacs package to bring powerful Python editing to Emacs. It combines and configures a number of other packages, both written in Emacs Lisp as well as Python.

FAS Account: lbazan

Comment 1 Chris Caron 2019-04-07 21:19:06 UTC
Package Build
=============
Builds Okay:
 - https://koji.fedoraproject.org/koji/taskinfo?taskID=34038420

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

Issues:
=======
- Sources used to build the package do not match the upstream source, as provided
  in the spec URL. Checksum differences are provided at the bottom of this review.
- Your .spec file identifies a GPL license, yet your GitHub page and tar.gz file
  includes a GPLv3 license.  I imagine this is just a typo in your spec?
- You should have a peek at https://fedoraproject.org/wiki/User:Bkabrda/EPEL7_Python3.
  From here you'll see some things you're doing nicely and some spots you just need
  a few tweeks such as:
     - drop reference to %{?python_enable_dependency_generator}
     - BuildRequires: %{py3_dist coverage} should read:
           BuildRequires: python%{python3_pkgversion}-coverage
     -  You need to apply this to all of the BuildRequrires.
- There are a few rpmlint warnings below which are not show-stoppers by any means, but
  useful to show as you can optionally fix them up too! :)
- %check is disabled; but i can see that recently python-yapf (bz#1691609) has been pushed
  upstream now. So you can turn that back on and try it out to see how it works for you.

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "GPL (v3 or later)". 307 files have
     unknown license. Detailed output of licensecheck in
     /home/l2g/Development/reviews/review-python-elpy/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[!]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Bad spec filename: /home/l2g/Development/reviews/review-python-
     elpy/srpm-unpacked/python-elpy.spec
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: python3-elpy-1.28.0-1.fc31.noarch.rpm
          python-elpy-1.28.0-1.fc31.src.rpm
python3-elpy.noarch: W: spelling-error Summary(en_US) Backend -> Backed, Back end, Back-end
python3-elpy.noarch: W: spelling-error %description -l en_US elpyThis -> Pythias
python3-elpy.noarch: W: invalid-license GPL
python-elpy.src: W: spelling-error Summary(en_US) Backend -> Backed, Back end, Back-end
python-elpy.src: W: spelling-error %description -l en_US elpyThis -> Pythias
python-elpy.src: W: invalid-license GPL
python-elpy.src:35: W: macro-in-comment %{py3_dist
python-elpy.src:61: W: macro-in-comment %check
python-elpy.src:62: W: macro-in-comment %{__python3}
python-elpy.src: E: specfile-error warning: Macro expanded in comment on line 35: %{py3_dist yapf}
2 packages and 0 specfiles checked; 1 errors, 9 warnings.


Source checksums
----------------
https://files.pythonhosted.org/packages/source/e/elpy/elpy-1.28.0.tar.gz :
  CHECKSUM(SHA256) this package     : f9ca80cbc52374b315b9985e7679e493a4d0426139f4c9a015fff4ba2e1f2851
  CHECKSUM(SHA256) upstream package : da613f2391c6f2c7ca38366325a1eab5d6007551fb0da0adaddc74a98c5ba653

Comment 2 Chris Caron 2019-04-07 21:37:51 UTC
Another minor comment, the %changelog is just missing a proper close > tag after your email.


Note You need to log in before you can comment on or make changes to this bug.